

#include "quakedef.h"
#include "menu_common.h"
#include "winquake.h"

// cvars used
extern cvar_t gl_texturedir;
extern cvar_t scr_screenshotformat;
extern cvar_t scr_screenshotdir;
extern cvar_t r_lerporient;
extern cvar_t r_lerpframe;
extern cvar_t r_lerplightstyle;
extern cvar_t host_savedir;
extern cvar_t m_filter;
extern cvar_t m_look;
extern cvar_t m_boost;
extern cvar_t chase_back;
extern cvar_t chase_up;
extern cvar_t chase_right;
extern cvar_t chase_active;
extern cvar_t chase_scale;
extern cvar_t ds_musicdir;
extern cvar_t sound_nominal_clip_dist;
extern cvar_t ambient_level;
extern cvar_t ambient_fade;
extern cvar_t r_monolight;
extern cvar_t r_extradlight;
extern cvar_t hud_defaulthud;
extern cvar_t r_warpspeed;
extern cvar_t r_lavaalpha;
extern cvar_t r_telealpha;
extern cvar_t r_slimealpha;
extern cvar_t m_directinput;
extern cvar_t in_joystick;
extern cvar_t m_accellevel;
extern cvar_t m_accelthreshold1;
extern cvar_t m_accelthreshold2;
extern cvar_t r_zhack;
extern cvar_t r_automapshot;

CQMenu menu_Main (NULL, m_main);
CQMenu menu_Singleplayer (&menu_Main, m_other);
CQMenu menu_Save (&menu_Singleplayer, m_save);
CQMenu menu_Load (&menu_Singleplayer, m_load);
CQMenu menu_Multiplayer (&menu_Main, m_multiplayer);
CQMenu menu_TCPIPNewGame (&menu_Multiplayer, m_lanconfig_newgame);
CQMenu menu_TCPIPJoinGame (&menu_Multiplayer, m_lanconfig_joingame);
CQMenu menu_GameConfig (&menu_TCPIPNewGame, m_gameoptions);
CQMenu menu_Setup (&menu_Multiplayer, m_setup);
CQMenu menu_Options (&menu_Main, m_options);
CQMenu menu_Video (&menu_Options, m_video);
CQMenu menu_Sound (&menu_Options, m_other);
CQMenu menu_Help (&menu_Main, m_help);
CQMenu menu_Input (&menu_Options, m_other);
CQMenu menu_Keybindings (&menu_Input, m_keys);
CQMenu menu_Effects (&menu_Options, m_other);
CQMenu menu_ContentDir (&menu_Options, m_other);
CQMenu menu_Chase (&menu_Options, m_other);
extern CQMenu menu_HUD;

// for use in various menus
char *SkillNames[] =
{
	"Easy",
	"Normal",
	"Hard",
	"NIGHTMARE",
	NULL
};


// these are temporary until we add a proper maps menu...
char *ID1Maps[] =
{
	// changed these to reflect the actual BSP internal names
	"Introduction (Welcome to Quake)",
	"The Slipgate Complex", "Castle of the Damned", "The Necropolis", "The Grisly Grotto", "Gloom Keep", "The Door To Chthon", "The House of Chthon", "Ziggurat Vertigo",
	"The Installation", "The Ogre Citadel", "The Crypt of Decay", "The Ebon Fortress", "The Wizard's Manse", "The Dismal Oubliette", "The Underearth", 
	"Termination Central", "The Vaults of Zin", "The Tomb of Terror", "Satan's Dark Delight", "The Wind Tunnels", "Chambers of Torment", "The Haunted Halls",
	"The Sewage System", "The Tower of Despair", "The Elder God Shrine", "The Palace of Hate", "Hell's Atrium", "The Pain Maze", "Azure Agony", "The Nameless City",
	"Shub-Niggurath's Pit",
	"Place of Two Deaths", "Claustrophobopolis", "The Abandoned Base", "The Bad Place", "The Cistern", "The Dark Zone",
	NULL
};


char *ID1BSPs[] =
{
	"start",
	"e1m1", "e1m2", "e1m3", "e1m4", "e1m5", "e1m6", "e1m7", "e1m8",
	"e2m1", "e2m2", "e2m3", "e2m4", "e2m5", "e2m6", "e2m7",
	"e3m1", "e3m2", "e3m3", "e3m4", "e3m5", "e3m6", "e3m7",
	"e4m1", "e4m2", "e4m3", "e4m4", "e4m5", "e4m6", "e4m7", "e4m8",
	"end",
	"dm1", "dm2", "dm3", "dm4", "dm5", "dm6",
	NULL
};


char *HipnoMaps[] =
{
	"Command HQ",
	"The Pumping Station", "Storage Facility", "The Lost Mine", "Research Facility", "Military Complex",
	"Ancient Realms", "The Black Cathedral", "The Catacombs", "The Crypt", "Mortum's Keep", "The Gremlin's Domain",
	"Tur Torment", "Pandemonium", "Limbo", "The Gauntlet",
	"Armagon's Lair",
	"The Edge of Oblivion",
	NULL
};


char *HipnoBSPs[] =
{
	"start",
	"hip1m1", "hip1m2", "hip1m3", "hip1m4", "hip1m5",
	"hip2m1", "hip2m2", "hip2m3", "hip2m4", "hip2m5", "hip2m6",
	"hip3m1", "hip3m2", "hip3m3", "hip3m4",
	"hipend",
	"hipdm1",
	NULL
};


char *RogueMaps[] =
{
	"Split Decision", "Deviant's Domain", "Dread Portal", "Judgement Call", "Cave of Death", "Towers of Wrath", "Temple of Pain",
	"Tomb of the Overlord", "Tempus Fugit", "Elemental Fury I", "Elemental Fury II", "Curse of Osiris", "Wizard's Keep",
	"Blood Sacrifice", "Last Bastion", "Source of Evil", "Division of Change", NULL
};


char *RogueBSPs[] =
{
	"start", "r1m1", "r1m2", "r1m3", "r1m4", "r1m5", "r1m6", "r1m7", "r2m1", "r2m2",
	"r2m3", "r2m4", "r2m5", "r2m6", "r2m7", "r2m8", "ctf1", NULL
};


/*
========================================================================================================================

					MAIN MENU

========================================================================================================================
*/

int m_save_demonum;

void Menu_ExitMenus (void)
{
	key_dest = key_game;
	m_state = m_none;
	cls.demonum = m_save_demonum;

	if (cls.demonum != -1 && !cls.demoplayback && cls.state != ca_connected) CL_NextDemo ();
}


void Menu_MainCustomEnter (void)
{
	m_save_demonum = cls.demonum;
	cls.demonum = -1;
}


void Menu_MainExitQuake (void)
{
//	if (sv.active)
		if (!Menu_MessageBox ("Are you sure you want to\nExit Quake?\n"))
			return;

	// exit
	key_dest = key_console;
	Host_Quit_f ();
}


void Menu_InitMainMenu (void)
{
	menu_Main.AddOption (new CQMenuBanner ("gfx/ttl_main.lmp"));
	menu_Main.AddOption (new CQMenuTitle ("Select a Submenu"));
	menu_Main.AddOption (new CQMenuSubMenu ("Single Player Menu", &menu_Singleplayer));
	menu_Main.AddOption (new CQMenuSpacer ());
	menu_Main.AddOption (new CQMenuSubMenu ("Multiplayer Menu", &menu_Multiplayer));
	menu_Main.AddOption (new CQMenuSpacer ());
	menu_Main.AddOption (new CQMenuSubMenu ("Configure Game Options", &menu_Options));
	menu_Main.AddOption (new CQMenuSpacer ());
	menu_Main.AddOption (new CQMenuSubMenu ("Help/Ordering", &menu_Help));
	menu_Main.AddOption (new CQMenuSpacer ());
	menu_Main.AddOption (new CQMenuCommand ("Exit Quake", Menu_MainExitQuake));
	menu_Main.AddOption (new CQMenuCustomEnter (Menu_MainCustomEnter));
	menu_Main.AddOption (new CQMenuCustomKey (K_ESCAPE, Menu_ExitMenus));
}


/*
========================================================================================================================

					OPTIONS MENU

========================================================================================================================
*/


// commands
void Host_WriteConfiguration (void);

void Menu_OptionsResetToDefaults (void)
{
	Cbuf_AddText ("exec default.cfg\n");
}


void Menu_OptionsGoToConsole (void)
{
	m_state = m_none;
	Con_ToggleConsole_f ();
}


char *key_bindnames[][2] =
{
	{"+attack", 		"Attack"},
	{"impulse 10", 		"Next Weapon"},
	{"impulse 12", 		"Previous Weapon"},
	{"+jump", 			"Jump/Swim up"},
	{"+forward", 		"Walk Forward"},
	{"+back", 			"Backpedal"},
	{"+left", 			"Turn Left"},
	{"+right", 			"Turn Right"},
	{"+speed", 			"Run"},
	{"+moveleft", 		"Step Left"},
	{"+moveright", 		"Step Right"},
	{"+strafe", 		"Sidestep"},
	{"+lookup", 		"Look Up"},
	{"+lookdown", 		"Look Down"},
	{"centerview", 		"Center View"},
	{"+mlook", 			"Mouse Look"},
	{"+klook", 			"Keyboard Look"},
	{"+moveup",			"Swim Up"},
	{"+movedown",		"Swim Down"}
};


bool keybind_grab = false;

#define	NUMBINDINGS		(sizeof (key_bindnames) / sizeof (key_bindnames[0]))

int bind_cursor = 0;


void Menu_FindKeybindingsForAction (char *action, int *twokeys)
{
	char	*b;

	twokeys[0] = twokeys[1] = -1;
	int l = strlen (action);
	int count = 0;

	for (int j = 0; j < 256; j++)
	{
		if (!(b = keybindings[j])) continue;

		if (!strncmp (b, action, l))
		{
			twokeys[count++] = j;

			if (count == 2) break;
		}
	}
}


int Menu_KeybindingsCustomDraw (int y)
{
	int keys[2];

	if (keybind_grab)
		Menu_PrintCenterWhite (y, "Press a Key or Button for this Action");
	else Menu_PrintCenterWhite (y, "Press ENTER to Change or BACKSPACE to Clear");

	Menu_PrintCenter (y + 15, DIVIDER_LINE);

	y += 30;

	for (int i = 0; i < NUMBINDINGS; i++)
	{
		// draw the current option highlight wider so that we have room for everything
		if (i == bind_cursor) Menu_HighlightBar (-200, y, 400);

		// action
		Menu_Print (124 - strlen (key_bindnames[i][1]) * 8, y, key_bindnames[i][1]);

		Menu_FindKeybindingsForAction (key_bindnames[i][0], keys);

		if (keys[0] == -1)
			Menu_Print (148, y, "(unbound)");
		else
		{
			char *name = Key_KeynumToString (keys[0]);
			Menu_PrintWhite (148, y, name);

			int x = strlen (name) * 8;

			if (keys[1] != -1)
			{
				Menu_Print (148 + x + 8, y, "or");
				Menu_PrintWhite (148 + x + 32, y, Key_KeynumToString (keys[1]));
			}
		}

		// next bind name
		y += 15;
	}

	return y;
}


void Menu_UnbindAction (char *action)
{
	char	*b;

	int l = strlen (action);

	for (int j = 0; j < 256; j++)
	{
		if (!(b = keybindings[j])) continue;
		if (!strncmp (b, action, l)) Key_SetBinding (j, "");
	}
}


// we need to manage the keys for this menu ourselves on account of bindings
void Menu_KeybindingsCustomKey (int key)
{
	if (keybind_grab)
	{
		menu_soundlevel = m_sound_enter;

		// ESC and the console key can never be bound
		if (key == K_ESCAPE)
		{
			// don't change the binding
			keybind_grab = false;
			return;
		}
		else if (key != '`')
		{
			// unbind the key from anything
			Key_SetBinding (key, "");

			// set the new binding
			char cmd[256];
			sprintf (cmd, "bind \"%s\" \"%s\"\n", Key_KeynumToString (key), key_bindnames[bind_cursor][0]);
			Cbuf_InsertText (cmd);
		}

		// exit binding mode
		keybind_grab = false;
		return;
	}

	// get keys for currently selected action
	int keys[2];
	Menu_FindKeybindingsForAction (key_bindnames[bind_cursor][0], keys);

	switch (key)
	{
	case K_ESCAPE:
		menu_Options.EnterMenu ();
		break;

	case K_UPARROW:
		menu_soundlevel = m_sound_nav;
		if ((--bind_cursor) < 0) bind_cursor = NUMBINDINGS - 1;
		break;

	case K_DOWNARROW:
		menu_soundlevel = m_sound_nav;
		if ((++bind_cursor) >= NUMBINDINGS) bind_cursor = 0;
		break;

	case K_ENTER:
		// go into bind mode
		menu_soundlevel = m_sound_query;
		keybind_grab = true;

		// if two keys are bound we delete the first binding
		if (keys[1] != -1) Menu_UnbindAction (key_bindnames[bind_cursor][0]);
		break;

	case K_BACKSPACE:
	case K_DEL:
		menu_soundlevel = m_sound_enter;

		if (keys[0] == -1)
		{
			// nothing to unbind
			menu_soundlevel = m_sound_deny;
		}
		else if (keys[1] == -1)
		{
			// unbind first key
			Key_SetBinding (keys[0], "");
		}
		else
		{
			// unbind second key
			Key_SetBinding (keys[1], "");
		}

		break;
	}
}

void Menu_VideoCustomEnter (void);

void Menu_InitOptionsMenu (void)
{
	// options
	menu_Options.AddOption (new CQMenuBanner ("gfx/p_option.lmp"));
	menu_Options.AddOption (new CQMenuTitle ("Configuration Management"));
	menu_Options.AddOption (new CQMenuCommand ("Go to Console", Menu_OptionsGoToConsole));
	menu_Options.AddOption (new CQMenuCommand ("Reset to Defaults", Menu_OptionsResetToDefaults));
	menu_Options.AddOption (new CQMenuCommand ("Save Current Configuration", Host_WriteConfiguration));
	menu_Options.AddOption (new CQMenuTitle ("Options"));
	menu_Options.AddOption (new CQMenuSubMenu ("Video and View Options", &menu_Video));
	menu_Options.AddOption (new CQMenuSubMenu ("Sound Options", &menu_Sound));
	menu_Options.AddOption (new CQMenuSubMenu ("Movement and Input Options", &menu_Input));
	menu_Options.AddOption (new CQMenuSubMenu ("Special Effects Options", &menu_Effects));
	menu_Options.AddOption (new CQMenuSubMenu ("Chase Camera Options", &menu_Chase));
	menu_Options.AddOption (new CQMenuSubMenu ("HUD Layout and Configuration", &menu_HUD));
	menu_Options.AddOption (new CQMenuSpacer (DIVIDER_LINE));
	menu_Options.AddOption (new CQMenuSubMenu ("Content Options", &menu_ContentDir));

	// sound
	menu_Sound.AddOption (new CQMenuBanner ("gfx/p_option.lmp"));
	menu_Sound.AddOption (new CQMenuTitle ("Sound Options"));
	menu_Sound.AddOption (new CQMenuCvarSlider ("Music Volume", &bgmvolume, 0, 1, 0.05));
	menu_Sound.AddOption (new CQMenuCvarSlider ("Sound Volume", &volume, 0, 1, 0.05));
	menu_Sound.AddOption (new CQMenuCvarSlider ("Clip Distance", &sound_nominal_clip_dist, 500, 2000, 100));
	menu_Sound.AddOption (new CQMenuCvarSlider ("Ambient Level", &ambient_level, 0, 1, 0.05));
	menu_Sound.AddOption (new CQMenuCvarSlider ("Ambient Fade", &ambient_fade, 50, 200, 10));

	// chase cam - now that it's fixed, let's expose the wee bugger
	menu_Chase.AddOption (new CQMenuBanner ("gfx/p_option.lmp"));
	menu_Chase.AddOption (new CQMenuTitle ("Chase Camera Options"));
	menu_Chase.AddOption (new CQMenuCvarToggle ("Chase Active", &chase_active, 0, 1));
	menu_Chase.AddOption (new CQMenuSpacer (DIVIDER_LINE));
	menu_Chase.AddOption (new CQMenuCvarSlider ("Chase Back", &chase_back, 50, 500, 25));
	menu_Chase.AddOption (new CQMenuCvarSlider ("Chase Up", &chase_up, -64, 256, 16));
	menu_Chase.AddOption (new CQMenuCvarSlider ("Chase Right", &chase_right, -64, 64, 8));
	menu_Chase.AddOption (new CQMenuSpacer (DIVIDER_LINE));
	menu_Chase.AddOption (new CQMenuCvarSlider ("Smoothness", &chase_scale, 0.2, 1.8, 0.1));

	// input
	menu_Input.AddOption (new CQMenuBanner ("gfx/p_option.lmp"));
	menu_Input.AddOption (new CQMenuTitle ("Input Options"));
	menu_Input.AddOption (new CQMenuSubMenu ("Customize Controls", &menu_Keybindings));
	menu_Input.AddOption (new CQMenuSpacer (DIVIDER_LINE));
	menu_Input.AddOption (new CQMenuCvarToggle ("Use DirectInput", &m_directinput));
	menu_Input.AddOption (new CQMenuCvarToggle ("Use Joystick", &in_joystick));
	menu_Input.AddOption (new CQMenuSpacer (DIVIDER_LINE));
	menu_Input.AddOption (new CQMenuCvarSlider ("Mouse Speed", &sensitivity, 1, 21, 1));
	menu_Input.AddOption (new CQMenuCvarSlider ("Mouse Acceleration", &m_accellevel, 0, 2, 1));
	menu_Input.AddOption (new CQMenuCvarSlider ("Threshold 1", &m_accelthreshold1, 0, 20, 1));
	menu_Input.AddOption (new CQMenuCvarSlider ("Threshold 2", &m_accelthreshold2, 0, 20, 1));
	menu_Input.AddOption (new CQMenuCvarSlider ("DirectInput Boost", &m_boost, 1, 5, 0.5));
	menu_Input.AddOption (new CQMenuCvarToggle ("Mouse Look", &m_look, 0, 1));
	menu_Input.AddOption (new CQMenuCvarToggle ("Mouse Filter", &m_filter, 0, 1));
	menu_Input.AddOption (new CQMenuCvarToggle ("Invert Mouse", &m_pitch, 0.022, -0.022));
	menu_Input.AddOption (new CQMenuTitle ("Movement Options"));
	menu_Input.AddOption (new CQMenuCvarToggle ("Always Run", &cl_forwardspeed, 200, 400));
	menu_Input.AddOption (new CQMenuCvarToggle ("Lookspring", &lookspring, 0, 1));
	menu_Input.AddOption (new CQMenuCvarToggle ("Lookstrafe", &lookstrafe, 0, 1));

	// effects
	menu_Effects.AddOption (new CQMenuBanner ("gfx/p_option.lmp"));
	menu_Effects.AddOption (new CQMenuTitle ("Interpolation"));
	menu_Effects.AddOption (new CQMenuCvarToggle ("Orientation", &r_lerporient, 0, 1));
	menu_Effects.AddOption (new CQMenuCvarToggle ("Frame", &r_lerpframe, 0, 1));
	menu_Effects.AddOption (new CQMenuCvarToggle ("Light Style", &r_lerplightstyle, 0, 1));
	menu_Effects.AddOption (new CQMenuTitle ("Water and Other Liquids"));
	menu_Effects.AddOption (new CQMenuCvarSlider ("Water Alpha", &r_wateralpha, 0, 1, 0.1));
	menu_Effects.AddOption (new CQMenuCvarSlider ("Warp Speed", &r_warpspeed, 1, 10, 1));
	menu_Effects.AddOption (new CQMenuCvarToggle ("Lava Alpha", &r_lavaalpha, 0, 1));
	menu_Effects.AddOption (new CQMenuCvarToggle ("Slime Alpha", &r_slimealpha, 0, 1));
	menu_Effects.AddOption (new CQMenuCvarToggle ("Teleport Alpha", &r_telealpha, 0, 1));
	menu_Effects.AddOption (new CQMenuCvarToggle ("Underwater Warp", &r_waterwarp, 0, 1));
	menu_Effects.AddOption (new CQMenuTitle ("Lighting"));
	menu_Effects.AddOption (new CQMenuCvarToggle ("Flash Blend", &gl_flashblend, 0, 1));
	menu_Effects.AddOption (new CQMenuCvarToggle ("Coloured Light", &r_monolight, 1, 0));
	menu_Effects.AddOption (new CQMenuCvarToggle ("Extra DLights", &r_extradlight, 0, 1));
	menu_Effects.AddOption (new CQMenuTitle ("Other Effects"));
	menu_Effects.AddOption (new CQMenuCvarToggle ("Z-Fighting Hack", &r_zhack, 0, 1));

	menu_ContentDir.AddOption (new CQMenuBanner ("gfx/p_option.lmp"));
	menu_ContentDir.AddOption (new CQMenuTitle ("General Content Options"));
	menu_ContentDir.AddOption (new CQMenuCvarToggle ("Automatic Mapshots", &r_automapshot, 0, 1));
	menu_ContentDir.AddOption (new CQMenuTitle ("Content Locations"));
	menu_ContentDir.AddOption (new CQMenuCvarTextbox ("Screenshots", &scr_screenshotdir));
	menu_ContentDir.AddOption (new CQMenuCvarTextbox ("Save Games", &host_savedir));
	menu_ContentDir.AddOption (new CQMenuCvarTextbox ("Textures", &gl_texturedir));
	menu_ContentDir.AddOption (new CQMenuCvarTextbox ("MP3 Music", &ds_musicdir));
	menu_ContentDir.AddOption (new CQMenuCvarTextbox ("Default HUD", &hud_defaulthud));
	menu_ContentDir.AddOption (new CQMenuTitle ("Warning"));
	menu_ContentDir.AddOption (new CQMenuSpacer ("These aren't as robust as they could be"));
	menu_ContentDir.AddOption (new CQMenuSpacer ("So don't try anything fancy"));

	// keybindings
	menu_Keybindings.AddOption (new CQMenuBanner ("gfx/ttl_cstm.lmp"));
	menu_Keybindings.AddOption (new CQMenuCustomDraw (Menu_KeybindingsCustomDraw));

	// grab every key for these actions
	for (int i = 0; i < 256; i++)
		menu_Keybindings.AddOption (new CQMenuCustomKey (i, Menu_KeybindingsCustomKey));

	// video menu - the rest of the options are deferred until the menu is up!
	// see Menu_VideoCustomEnter in d3d_vidnt.cpp
	menu_Video.AddOption (new CQMenuBanner ("gfx/vidmodes.lmp"));
	menu_Video.AddOption (new CQMenuTitle ("Configure Video Modes"));
	menu_Video.AddOption (new CQMenuCustomEnter (Menu_VideoCustomEnter));
}


/*
========================================================================================================================

					HELP MENU

========================================================================================================================
*/

int menu_HelpPage = 0;
#define	NUM_HELP_PAGES	6


void Menu_HelpCustomEnter (void)
{
	// switch the help page depending on whether we're playing the registered version or not
	if (registered.value)
		menu_HelpPage = 1;
	else menu_HelpPage = 0;
}


int Menu_HelpCustomDraw (int y)
{
	qpic_t *pic = Draw_CachePic (va ("gfx/help%i.lmp", menu_HelpPage));
	Draw_Pic ((vid.width - pic->width) >> 1, y, pic);
	return y + pic->height + 10;
}


void Menu_HelpCustomKey (int key)
{
	menu_soundlevel = m_sound_option;

	switch (key)
	{
	case K_UPARROW:
	case K_RIGHTARROW:
		if (registered.value)
		{
			if (++menu_HelpPage >= NUM_HELP_PAGES)
				menu_HelpPage = 1;
		}
		else
		{
			if (++menu_HelpPage >= NUM_HELP_PAGES)
				menu_HelpPage = 0;
		}
		break;

	case K_DOWNARROW:
	case K_LEFTARROW:
		if (registered.value)
		{
			if (--menu_HelpPage < 1)
				menu_HelpPage = NUM_HELP_PAGES - 1;
		}
		else
		{
			if (--menu_HelpPage < 0)
				menu_HelpPage = NUM_HELP_PAGES - 1;
		}
		break;
	}
}


void Menu_InitHelpMenu (void)
{
	menu_Help.AddOption (new CQMenuCustomEnter (Menu_HelpCustomEnter));
	menu_Help.AddOption (new CQMenuCustomDraw (Menu_HelpCustomDraw));
	menu_Help.AddOption (new CQMenuCustomKey (K_LEFTARROW, Menu_HelpCustomKey));
	menu_Help.AddOption (new CQMenuCustomKey (K_UPARROW, Menu_HelpCustomKey));
	menu_Help.AddOption (new CQMenuCustomKey (K_DOWNARROW, Menu_HelpCustomKey));
	menu_Help.AddOption (new CQMenuCustomKey (K_RIGHTARROW, Menu_HelpCustomKey));
}

